# $Revision: 1.30 $, $Date: 2011/02/19 17:50:53 $
#
# Conditional build:
%bcond_without	asmopt	# without assembler optimization for i686+
#
# disable asmopt where not applicable
%ifarch i386 i486 i586
%undefine	with_asmopt
%endif
%ifnarch %{ix86}
%undefine	with_asmopt
%endif
%define		realname		zlib
Summary:	Library for compression and decompression - MinGW32 cross version
Summary(pl.UTF-8):	Biblioteka z podprogramami do kompresji i dekompresji - wersja skrośna dla MinGW32
Name:		crossmingw32-%{realname}
Version:	1.2.5
Release:	3
License:	BSD
Group:		Development/Libraries
Source0:	http://www.zlib.net/current/%{realname}-%{version}.tar.gz
# Source0-md5:	c735eab2d659a96e5a594c9e8541ad63
Patch0:		%{name}-LFS.patch
Patch1:		%{realname}-lfs.patch
URL:		http://www.zlib.net/
BuildRequires:	crossmingw32-gcc
BuildRequires:	sed >= 4.0
Requires:	crossmingw32-runtime
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		no_install_post_strip	1

%define		target			i386-mingw32
%define		target_platform 	i386-pc-mingw32

%define		_sysprefix		/usr
%define		_prefix			%{_sysprefix}/%{target}
%define		_libdir			%{_prefix}/lib
%define		_pkgconfigdir		%{_prefix}/lib/pkgconfig
%define		_dlldir			/usr/share/wine/windows/system
%define		__cc			%{target}-gcc
%define		__cxx			%{target}-g++
%define		filterout_ld	        -Wl,-z,.*
%define		filterout_c	        -gdwarf-3

%ifarch alpha sparc sparc64 sparcv9
%define		optflags	-O2
%endif

%description
The 'zlib' compression library provides in-memory compression and
decompression functions, including integrity checks of the
uncompressed data. This version of the library supports only one
compression method (deflation) but other algorithms may be added later
and will have the same stream interface.

This package contains the cross version for Win32.

%description -l pl.UTF-8
Biblioteka zlib udostępnia podprogramy do kompresji i dekompresji w
pamięci operacyjnej włącznie ze sprawdzaniem integralności w trakcie
dekompresji. Ta wersja biblioteki udostępnia tylko jedną metodę
kompresji o nazwie deflation niemniej inne algorytmy mogą być
dodawane udostępniając taki sam interfejs funkcji operujących na
strumieniu danych.

Ten pakiet zawiera wersję skrośną dla Win32.

%package static
Summary:	Static zlib library (cross MinGW32 version)
Summary(pl.UTF-8):	Statyczna biblioteka zlib (wersja skrośna MinGW32)
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description static
Static zlib library (cross MinGW32 version).

%description static -l pl.UTF-8
Statyczna biblioteka zlib (wersja skrośna MinGW32).

%package dll
Summary:	zlib - DLL library for Windows
Summary(pl.UTF-8):	zlib - biblioteka DLL dla Windows
Group:		Applications/Emulators
Requires:	wine

%description dll
zlib - DLL library for Windows.

%description dll -l pl.UTF-8
zlib - biblioteka DLL dla Windows.

%prep
%setup -q -n %{realname}-%{version}
%patch0 -p1
%patch1 -p1

%if %{with asmopt}
%ifarch i686 athlon
cp contrib/asm686/match.S .
%endif
%endif

%build
%{__make} -fwin32/Makefile.gcc all \
	CC="%{__cc}" \
	CXX="%{__cxx}" \
	AR="%{target}-ar" \
	RANLIB="%{target}-ranlib" \
	CFLAGS="-D_REENTRANT -D_LARGEFILE64_SOURCE=1 %{rpmcflags}%{?with_asmopt: -DASMV}" \
	DLLWRAP="%{target}-dllwrap" \
	RC="%{target}-windres" \
	CP="install" \
	IMPLIB="libz.dll.a" \
	prefix="%{_prefix}" \
	%{?with_asmopt:OBJA=match.o}

# used by libtool to detect dependencies
cat << "EOF" >> libz.la
# libz.la - a libtool library file
# Generated by ltmain.sh - GNU libtool 1.5.22 (1.1220.2.365 2005/12/18 22:14:06)
# ^^^^ This line needs to stay
# Made by czarny czarny at pld-linux.org

# The name that we can dlopen(3).
dlname='%{_dlldir}/zlib1.dll'

# Names of this library.
library_names='libz.dll.a'

# The name of the static archive.
old_library='libz.a'

# Libraries that this one depends upon.
dependency_libs=''

# Version information for libz.
current=0
age=0
revision=0

# Is this an already installed library?
installed=yes

# Should we warn about portability when linking against -modules?
shouldnotlink=no

# Files to dlopen/dlpreopen
dlopen=''
dlpreopen=''

# Directory that this library needs to be installed in:
libdir='%{_libdir}'
EOF

sed -e 's=@prefix@=%{_prefix}=;s=@exec_prefix@=%{_prefix}=;s=@\(shared\)\?libdir@=%{_libdir}=;s=@includedir@=%{_includedir}=;s=@VERSION@=%{version}=' \
	< zlib.pc.in > zlib.pc

%if 0%{!?debug:1}
%{target}-strip -R.comment -R.note zlib1.dll
%{target}-strip -g -R.comment -R.note *.a
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_libdir},%{_includedir},%{_dlldir},%{_pkgconfigdir}}

install zlib.h $RPM_BUILD_ROOT%{_includedir}
install zconf.h $RPM_BUILD_ROOT%{_includedir}
install libz.dll.a $RPM_BUILD_ROOT%{_libdir}
install libz.a $RPM_BUILD_ROOT%{_libdir}
install libz.la $RPM_BUILD_ROOT%{_libdir}
install zlib1.dll $RPM_BUILD_ROOT%{_dlldir}
install zlib.pc $RPM_BUILD_ROOT%{_pkgconfigdir}

rm -rf $RPM_BUILD_ROOT%{_datadir}/man

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%{_libdir}/libz.dll.a
%{_libdir}/libz.la
%{_includedir}/zconf.h
%{_includedir}/zlib.h
%{_pkgconfigdir}/zlib.pc

%files static
%defattr(644,root,root,755)
%{_libdir}/libz.a

%files dll
%defattr(644,root,root,755)
%{_dlldir}/zlib1.dll

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: crossmingw32-zlib.spec,v $
Revision 1.30  2011/02/19 17:50:53  wiget
- fix dlname in libtool file
- filter out some compiler and linker flags

Revision 1.29  2010/10/03 16:16:01  qboosh
- fixed sharedlibdir in zlib.pc
- release 3

Revision 1.28  2010/09/19 05:39:01  qboosh
- unified MinGW32 caps

Revision 1.27  2010/05/24 19:59:27  qboosh
- added lfs patch
- release 2

Revision 1.26  2010/04/21 07:21:03  qboosh
- updated to 1.2.5

Revision 1.25  2010/03/21 12:32:23  qboosh
- added LFS patch to export *64 functions from DLL
- release 3

Revision 1.24  2010/03/21 10:08:06  qboosh
- import library must be named libz.dll.a for -lz to work
- asm586 is no more (dropped upstream)

Revision 1.23  2010/03/18 22:47:39  wiget
- use win32/Makefile.gcc for building (for compatibility with other zlib DLL distributors)
- drop shared.patch (unused now)
- drop hacking unused configure
- don't include zutil.h in package (zlib internal file)
- release 2
NOTE: DLL file name change

Revision 1.22  2010/03/15 07:59:01  qboosh
- updated to 1.2.4 (adds LFS)
- updated shared patch, removed obsolete asmopt patch

Revision 1.21  2008/01/11 22:45:53  qboosh
- force %{_lib}-independent libdir
- release 4

Revision 1.20  2008-01-07 21:55:51  qboosh
- release 3 (2 disappeared)

Revision 1.19  2007-10-07 10:36:57  deejay1
- rel. 2 (needed to build cross freetype)

Revision 1.18  2007/03/06 17:36:11  qboosh
- cleanup, separated -static

Revision 1.17  2007/02/25 15:02:57  czarny
- build using configure
- static + shared version
- custom .la file

Revision 1.16  2007/02/12 21:23:51  glen
- tabs in preamble

Revision 1.15  2007/02/12 00:48:43  baggins
- converted to UTF-8

Revision 1.14  2006/05/28 01:27:59  wolf
- 1.2.3

Revision 1.13  2004/09/16 11:47:21  wolf
- rel 2 to rebuild with gcc 3.4.2

Revision 1.12  2004/08/30 18:54:03  qboosh
- updated to 1.2.1.1, added infsec patch (fixes CAN-2004-0797)

Revision 1.11  2004/02/28 17:31:12  saq
- more general ix86 %%ifarchs

Revision 1.10  2004/02/21 18:36:40  wolf
- fix alpha, sparc

Revision 1.9  2003/12/25 12:40:54  qboosh
- restored debug support

Revision 1.8  2003/12/25 02:21:16  wolf
- shared lib support

[3:20 wolf@bajzel:~/tmp]% i386-mingw32-gcc example.c -o example.exe -lz
[3:20 wolf@bajzel:~/tmp]% i386-mingw32-strip example.exe
[3:20 wolf@bajzel:~/tmp]% ls -l example.exe
-rwxr-xr-x    1 wolf     wheel       10752 2003-12-25 03:20 example.exe
[3:20 wolf@bajzel:~/tmp]% ./example.exe
zlib version 1.2.1 = 0x1210, compile flags = 0x255
(...)

Revision 1.7  2003/12/01 20:28:34  qboosh
- standard buildroot

Revision 1.6  2003/12/01 19:40:57  qboosh
- strip libz.a

Revision 1.5  2003/11/30 23:45:48  qboosh
- R: crossmingw32-runtime

Revision 1.4  2003/11/30 23:36:52  qboosh
- updated to 1.2.1, fixed build (static-only) and files

Revision 1.3  2003/08/29 23:30:33  ankry
- sync summaries / descriptions; some BR fixed

Revision 1.2  2003/08/27 12:03:28  ggodlewski
- release corrected

Revision 1.1  2003/08/27 12:02:34  ggodlewski
- 1st release
